%{
#include <stdlib.h> /* for atoi() */
#include <string.h> /* for strcpy() and exit() */
#include <stdio.h> /* for printf() */
#include "example.h"
%}

IDENT [A-Za-z][A-Za-z0-9]*
NUMERAL ([1-9][0-9]*)|0

%option noyywrap

%%

"print" 	{ return PRINT; }
"if"		{ return IF; }
"then"		{ return THEN; }
"else"		{ return ELSE; }
"endif"		{ return ENDIF; }
{NUMERAL}	{ yylval.int_val = atoi(yytext); return NUMERAL; }
{IDENT}		{ strcpy(yylval.ident_name, yytext); return IDENT; }
"=="		{ return EQ; }
"<"		{ return '<'; }
">"		{ return '>'; }
"="		{ return '='; }
"**"		{ return POW; }
"+"		{ return '+'; }
"-"		{ return '-'; }
"*"		{ return '*'; }
"/"		{ return '/'; }
"("		{ return '('; }
")"		{ return ')'; }
\n|;		{ return '\n'; }
" "		{ /* space - do nothing */ }
.		{ printf("Lexical error: symbol '%c'!\n", yytext[0]); exit(1); }

%%
